NativeWith (Rhino)
Date: 2018-10-23

org.mozilla.javascript

## Class NativeWith

- java.lang.Object
- - org.mozilla.javascript.NativeWith

- All Implemented Interfaces:
    java.io.Serializable, IdFunctionCall, Scriptable

      public class NativeWith
      extends java.lang.Object
      implements Scriptable, IdFunctionCall, java.io.Serializable

  This class implements the object lookup required for the `with` statement. It simply delegates every action to its prototype except for operations on its parent.
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Scriptable` | `parent`
    `protected Scriptable` | `prototype`

    - ### Fields inherited from interface org.mozilla.javascript.Scriptable

      `NOT_FOUND`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `NativeWith(Scriptable parent, Scriptable prototype)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `delete(int index)` Removes a property from this object.
    `void` | `delete(java.lang.String id)` Removes a property from this object.
    `java.lang.Object` | `execIdCall(IdFunctionObject f, Context cx, Scriptable scope, Scriptable thisObj, java.lang.Object[] args)` 'thisObj' will be null if invoked as constructor, in which case instance of Scriptable should be returned
    `java.lang.Object` | `get(int index, Scriptable start)` Get a property from the object selected by an integral index.
    `java.lang.Object` | `get(java.lang.String id, Scriptable start)` Get a named property from the object.
    `java.lang.String` | `getClassName()` Get the name of the set of objects implemented by this Java class.
    `java.lang.Object` | `getDefaultValue(java.lang.Class<?> typeHint)` Get the default value of the object with a given hint.
    `java.lang.Object[]` | `getIds()` Get an array of property ids.
    `Scriptable` | `getParentScope()` Get the parent scope of the object.
    `Scriptable` | `getPrototype()` Get the prototype of the object.
    `boolean` | `has(int index, Scriptable start)` Indicates whether or not an indexed property is defined in an object.
    `boolean` | `has(java.lang.String id, Scriptable start)` Indicates whether or not a named property is defined in an object.
    `boolean` | `hasInstance(Scriptable value)` The instanceof operator.
    `void` | `put(int index, Scriptable start, java.lang.Object value)` Sets an indexed property in this object.
    `void` | `put(java.lang.String id, Scriptable start, java.lang.Object value)` Sets a named property in this object.
    `void` | `setParentScope(Scriptable parent)` Set the parent scope of the object.
    `void` | `setPrototype(Scriptable prototype)` Set the prototype of the object.
    `protected java.lang.Object` | `updateDotQuery(boolean value)` Must return null to continue looping or the final collection result.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### prototype

          protected Scriptable prototype

    - #### parent

          protected Scriptable parent

  - ### Constructor Detail

    - #### NativeWith

          protected NativeWith(Scriptable parent,
                    Scriptable prototype)

  - ### Method Detail

    - #### getClassName

          public java.lang.String getClassName()

      Description copied from interface: `Scriptable`
      Get the name of the set of objects implemented by this Java class. This corresponds to the [[Class]] operation in ECMA and is used by Object.prototype.toString() in ECMA.

      See ECMA 8.6.2 and 15.2.4.2.

      Specified by:
        `getClassName` in interface `Scriptable`

    - #### has

          public boolean has(java.lang.String id,
                    Scriptable start)

      Description copied from interface: `Scriptable`
      Indicates whether or not a named property is defined in an object. Does not traverse the prototype chain.

      The property is specified by a String name as defined for the `get` method.

      Specified by:
        `has` in interface `Scriptable`
      Parameters:
        `id` - the name of the property
        `start` - the object in which the lookup began
      Returns:
        true if and only if the named property is found in the object
      See Also:
        `Scriptable.get(String, Scriptable)`, `ScriptableObject.getProperty(Scriptable, String)`

    - #### has

          public boolean has(int index,
                    Scriptable start)

      Description copied from interface: `Scriptable`
      Indicates whether or not an indexed property is defined in an object. Does not traverse the prototype chain.

      The property is specified by an integral index as defined for the `get` method.

      Specified by:
        `has` in interface `Scriptable`
      Parameters:
        `index` - the numeric index for the property
        `start` - the object in which the lookup began
      Returns:
        true if and only if the indexed property is found in the object
      See Also:
        `Scriptable.get(int, Scriptable)`, `ScriptableObject.getProperty(Scriptable, int)`

    - #### get

          public java.lang.Object get(java.lang.String id,
                             Scriptable start)

      Description copied from interface: `Scriptable`
      Get a named property from the object. Looks property up in this object and returns the associated value if found. Returns NOT_FOUND if not found. Note that this method is not expected to traverse the prototype chain. This is different from the ECMA [[Get]] operation. Depending on the property selector, the runtime will call this method or the form of `get` that takes an integer:

      JavaScript code | Java code
      --- | ---
      a.b | a.get("b", a)
      a["foo"] | a.get("foo", a)
      a[3] | a.get(3, a)
      a["3"] | a.get(3, a)
      a[3.0] | a.get(3, a)
      a["3.0"] | a.get("3.0", a)
      a[1.1] | a.get("1.1", a)
      a[-4] | a.get(-4, a)

      The values that may be returned are limited to the following:

      - java.lang.Boolean objects
      - java.lang.String objects
      - java.lang.Number objects
      - org.mozilla.javascript.Scriptable objects
      - null
      - The value returned by Context.getUndefinedValue()
      - NOT_FOUND
      Specified by:
        `get` in interface `Scriptable`
      Parameters:
        `id` - the name of the property
        `start` - the object in which the lookup began
      Returns:
        the value of the property (may be null), or NOT_FOUND
      See Also:
        `Context.getUndefinedValue()`

    - #### get

          public java.lang.Object get(int index,
                             Scriptable start)

      Description copied from interface: `Scriptable`
      Get a property from the object selected by an integral index. Identical to `get(String, Scriptable)` except that an integral index is used to select the property.
      Specified by:
        `get` in interface `Scriptable`
      Parameters:
        `index` - the numeric index for the property
        `start` - the object in which the lookup began
      Returns:
        the value of the property (may be null), or NOT_FOUND
      See Also:
        `Scriptable.get(String,Scriptable)`

    - #### put

          public void put(java.lang.String id,
                 Scriptable start,
                 java.lang.Object value)

      Description copied from interface: `Scriptable`
      Sets a named property in this object.

      The property is specified by a string name as defined for `get`.

      The possible values that may be passed in are as defined for `get`. A class that implements this method may choose to ignore calls to set certain properties, in which case those properties are effectively read-only.

      For properties defined in a prototype chain, use `putProperty` in ScriptableObject.

      Note that if a property a is defined in the prototype p of an object o, then evaluating `o.a = 23` will cause `set` to be called on the prototype p with o as the start parameter. To preserve JavaScript semantics, it is the Scriptable object's responsibility to modify o.

      This design allows properties to be defined in prototypes and implemented in terms of getters and setters of Java values without consuming slots in each instance.

      The values that may be set are limited to the following:

      - java.lang.Boolean objects
      - java.lang.String objects
      - java.lang.Number objects
      - org.mozilla.javascript.Scriptable objects
      - null
      - The value returned by Context.getUndefinedValue()

      Arbitrary Java objects may be wrapped in a Scriptable by first calling `Context.toObject`. This allows the property of a JavaScript object to contain an arbitrary Java object as a value.

      Note that `has` will be called by the runtime first before `set` is called to determine in which object the property is defined. Note that this method is not expected to traverse the prototype chain, which is different from the ECMA [[Put]] operation.

      Specified by:
        `put` in interface `Scriptable`
      Parameters:
        `id` - the name of the property
        `start` - the object whose property is being set
        `value` - value to set the property to
      See Also:
        `Scriptable.has(String, Scriptable)`, `Scriptable.get(String, Scriptable)`, `ScriptableObject.putProperty(Scriptable, String, Object)`, `Context.toObject(Object, Scriptable)`

    - #### put

          public void put(int index,
                 Scriptable start,
                 java.lang.Object value)

      Description copied from interface: `Scriptable`
      Sets an indexed property in this object.

      The property is specified by an integral index as defined for `get`.

      Identical to `put(String, Scriptable, Object)` except that an integral index is used to select the property.

      Specified by:
        `put` in interface `Scriptable`
      Parameters:
        `index` - the numeric index for the property
        `start` - the object whose property is being set
        `value` - value to set the property to
      See Also:
        `Scriptable.has(int, Scriptable)`, `Scriptable.get(int, Scriptable)`, `ScriptableObject.putProperty(Scriptable, int, Object)`, `Context.toObject(Object, Scriptable)`

    - #### delete

          public void delete(java.lang.String id)

      Description copied from interface: `Scriptable`
      Removes a property from this object. This operation corresponds to the ECMA [[Delete]] except that the no result is returned. The runtime will guarantee that this method is called only if the property exists. After this method is called, the runtime will call Scriptable.has to see if the property has been removed in order to determine the boolean result of the delete operator as defined by ECMA 11.4.1.

      A property can be made permanent by ignoring calls to remove it.

      The property is specified by a String name as defined for `get`.

      To delete properties defined in a prototype chain, see deleteProperty in ScriptableObject.

      Specified by:
        `delete` in interface `Scriptable`
      Parameters:
        `id` - the identifier for the property
      See Also:
        `Scriptable.get(String, Scriptable)`, `ScriptableObject.deleteProperty(Scriptable, String)`

    - #### delete

          public void delete(int index)

      Description copied from interface: `Scriptable`
      Removes a property from this object. The property is specified by an integral index as defined for `get`.

      To delete properties defined in a prototype chain, see deleteProperty in ScriptableObject. Identical to `delete(String)` except that an integral index is used to select the property.

      Specified by:
        `delete` in interface `Scriptable`
      Parameters:
        `index` - the numeric index for the property
      See Also:
        `Scriptable.get(int, Scriptable)`, `ScriptableObject.deleteProperty(Scriptable, int)`

    - #### getPrototype

          public Scriptable getPrototype()

      Description copied from interface: `Scriptable`
      Get the prototype of the object.
      Specified by:
        `getPrototype` in interface `Scriptable`
      Returns:
        the prototype

    - #### setPrototype

          public void setPrototype(Scriptable prototype)

      Description copied from interface: `Scriptable`
      Set the prototype of the object.
      Specified by:
        `setPrototype` in interface `Scriptable`
      Parameters:
        `prototype` - the prototype to set

    - #### getParentScope

          public Scriptable getParentScope()

      Description copied from interface: `Scriptable`
      Get the parent scope of the object.
      Specified by:
        `getParentScope` in interface `Scriptable`
      Returns:
        the parent scope

    - #### setParentScope

          public void setParentScope(Scriptable parent)

      Description copied from interface: `Scriptable`
      Set the parent scope of the object.
      Specified by:
        `setParentScope` in interface `Scriptable`
      Parameters:
        `parent` - the parent scope to set

    - #### getIds

          public java.lang.Object[] getIds()

      Description copied from interface: `Scriptable`
      Get an array of property ids. Not all property ids need be returned. Those properties whose ids are not returned are considered non-enumerable.
      Specified by:
        `getIds` in interface `Scriptable`
      Returns:
        an array of Objects. Each entry in the array is either a java.lang.String or a java.lang.Number

    - #### getDefaultValue

          public java.lang.Object getDefaultValue(java.lang.Class<?> typeHint)

      Description copied from interface: `Scriptable`
      Get the default value of the object with a given hint. The hints are String.class for type String, Number.class for type Number, Scriptable.class for type Object, and Boolean.class for type Boolean.

      A `hint` of null means "no hint". See ECMA 8.6.2.6.

      Specified by:
        `getDefaultValue` in interface `Scriptable`
      Parameters:
        `typeHint` - the type hint
      Returns:
        the default value

    - #### hasInstance

          public boolean hasInstance(Scriptable value)

      Description copied from interface: `Scriptable`
      The instanceof operator.

      The JavaScript code "lhs instanceof rhs" causes rhs.hasInstance(lhs) to be called.

      The return value is implementation dependent so that embedded host objects can return an appropriate value. See the JS 1.3 language documentation for more detail.

      This operator corresponds to the proposed EMCA [[HasInstance]] operator.

      Specified by:
        `hasInstance` in interface `Scriptable`
      Parameters:
        `value` - The value that appeared on the LHS of the instanceof operator
      Returns:
        an implementation dependent value

    - #### updateDotQuery

          protected java.lang.Object updateDotQuery(boolean value)

      Must return null to continue looping or the final collection result.

    - #### execIdCall

          public java.lang.Object execIdCall(IdFunctionObject f,
                                    Context cx,
                                    Scriptable scope,
                                    Scriptable thisObj,
                                    java.lang.Object[] args)

      Description copied from interface: `IdFunctionCall`
      'thisObj' will be null if invoked as constructor, in which case instance of Scriptable should be returned
      Specified by:
        `execIdCall` in interface `IdFunctionCall`